#include <iom16v.h>
#include <macros.h>
#define uint unsigned int
#define uchar  unsigned char
uchar  ack;				//ack=1,,ack=0,ʾӦ
#define SLA_W       0xa0  	//ӻַ,д
#define SLA_R        0xa1  	//ӻַ,
#define SCL_CLR	PORTB &= ~(1 << PB6)	//ƽõ
#define SCL_SET	PORTB |= (1 << PB6)		//ƽø
#define SCL_IN		DDRB &= ~(1 << PB6)	//
#define SCL_OUT	DDRB |= (1 << PB6)		//
#define SDA_CLR	PORTB &= ~(1 << PB7)	//ƽõ
#define SDA_SET	PORTB |= (1 << PB7)		//ƽø
#define SDA_R		PINB & (1 << PB7)		//ƽȡ
#define SDA_IN		DDRB &= ~(1 << PB7)	//
#define SDA_OUT	DDRB |= (1 << PB7)		//
/****************/
void delay_us(uint us);		//ʱ
void I2C_start(void);		//źź
void I2C_stop(void);		//ֹͣźź
void  I2C_init(void);		//I2C߳ʼ
void  I2C_Ack(void);		//Ӧźź
void  I2C_NAck(void);	//Ӧźź
uchar RecByte(void);		//գһֽݺ
uchar SendByte(uchar write_data) ;//ͣдһֽݺ
void write_EEPROM(uchar value,uint addr);//ַָдһֽݺ
uchar read_EEPROM(uint addr);		//ȡĳһַݺ
uchar  read_nbyte (uchar SLA,uchar SUBA,uchar *pdat,uchar n);//()nֽݺ
uchar  write_nbyte(uchar SLA,uchar SUBA,uchar *pdat,uchar n);//(д)nֽݺ
/********usʱ********/
void delay_us(uint us)		  
{
 uint i;
 us=us*5/4;		  	 //5/48MHz£ͨ淴ʵõֵ
 for( i=0;i<us;i++); 
}
/********I2C********/
void I2C_start(void)
{ 
SDA_SET; 
	SCL_SET;  
  delay_us(11);
  SDA_CLR;
  delay_us(11);
  SCL_CLR;	
}
/********I2Cֹͣ********/
void I2C_stop(void)
{
SDA_CLR; 
  delay_us(11); 
  SCL_SET;   
  delay_us(11); 
  SDA_SET;  
}
/********I2C߳ʼ********/
void  I2C_init()
{
  SCL_CLR;
  I2C_stop();
}
/********Ӧ********/
void  I2C_Ack()
{
  SDA_CLR;
  SCL_SET;
 	delay_us(11);
  SCL_CLR;
  SDA_SET;
}
/********ͷӦ********/
void  I2C_NAck()
{
  SDA_SET;
  SCL_SET;
  delay_us(11);   
SCL_CLR;
  SDA_CLR;  
}
/********I2CоƬ()һֽݺ********/
uchar RecByte()
{
  uchar i=8,temp=0;
  SDA_IN;
  delay_us(11);
  while (i--)
{
  	SCL_SET;  
       temp<<=1;
       if (SDA_R){temp++;} 
       SCL_CLR; 
       delay_us(11);
  }
  SDA_OUT;
  return temp;
}
/********I2CоƬ(д)һֽݺ********/
uchar SendByte(uchar write_data) 
{
  uchar i=8;
  while (i--)
{
  	if (write_data&0x80){SDA_SET;}else{SDA_CLR;}
       write_data<<=1; 
       delay_us(11);
       SCL_SET; 
       delay_us(11);
       SCL_CLR; 
  }
  SDA_SET;  
  delay_us(11);
  SCL_SET;   
  SDA_IN;
	delay_us(11);
  if (SDA_R){ack=0;}else{ack=1;}
  SCL_CLR; 
  SDA_OUT;
delay_us(11);
return ack;               //Ӧλ
}
/********24CXXַָдһֽݺ********/
void write_EEPROM(uchar value,uint addr)
{
uchar i=3;
  SDA_OUT;
	SCL_OUT;
  while (i--)
{
  	I2C_start();
       SendByte(SLA_W); 
 		if (ack==0)
		{
        	I2C_stop();
            	continue;
        }
        SendByte(addr);
  	if (ack==0)
{ 
        	I2C_stop(); 
            	continue;
        } 
        SendByte(value);
 		if (ack==0)
{
            I2C_stop(); 
            continue; 
        }
        I2C_stop();
		if(!(ack==0))break;
     }   
}
/********24CXXַָȡһֽݺ********/
uchar read_EEPROM(uint addr)
{
 	uchar  value;
  SDA_OUT;
	SCL_OUT;
	I2C_start();
  SendByte(SLA_W);
  SendByte(addr); 
  I2C_start();
  SendByte(SLA_R);
  value=RecByte();
  I2C_stop(); 
  return value;
}
/********24CXXдֽݺ********/
uchar  write_nbyte(uchar SLA,uchar SUBA,uchar *pdat,uchar n)
{
  uchar  s;
  I2C_start();
  SendByte(SLA);          //ַ
  if(ack==0) return(0);
  SendByte(SUBA);        //ӵַ
  if(ack==0) return(0);
for(s=0; s<n; s++)
  {
   	SendByte(*pdat);      //
     	if(ack==0) return(0);
     	pdat++;
   }
   I2C_stop();               //
   return(1);
}
/********24CXXȡֽݺ********/
uchar  read_nbyte (uchar SLA,uchar SUBA,uchar *pdat,uchar n)
{
uchar  s;
	I2C_start();
  SendByte(SLA);          //ַ
  if(ack==0) return(0);
  SendByte(SUBA);        //ӵַ
  if(ack==0) return(0);
  I2C_start();
  SendByte(SLA+1);        //дַ
  if(ack==0) return(0);
	for(s=0; s<n; s++)
  {
  	*pdat=RecByte();      //
    	I2C_Ack();             //Ӧλ
    	pdat++;
   }
   I2C_NAck();               //ͷӦ
   I2C_stop();               //
   return(1);
}


